function love.load()
  mapWidth = 5
  mapHeight = 5

  print("Loading map...")
  --file = io.open("world.map", "rb")
  local mapdata = love.filesystem.read( "small.map" )

  --local mapdata = file:read("*all")

  i = 0
  map = {}
  for x=1,mapWidth do
    map[x] = {}
    for y=1,mapHeight do
      --print(type(tonumber(mapdata.byte((x-1) * (y-1) + x))), tonumber(mapdata.byte((x-1) * (y-1) + x)))
      i = i+1
      map[x][y] = string.char(mapdata.byte(i)-1)
      --print(map[x][y])
    end
  end
  print("Done")

  print("Loading graphics...")
  tilesetImage = love.graphics.newImage( "tileset.png" )
  tilesetImage:setFilter("nearest", "linear") -- this "linear filter" removes some artifacts if we were to scale the tiles
  tileSizeX = 40
  tileSizeY = 72
  tileNum = 17

  mapX = 1
  mapY = 1
  tilesDisplayWidth = 5
  tilesDisplayHeight = 5
 
  zoomX = 1
  zoomY = 1

  tileQuads = {}
  for i=1,tileNum do
    tileQuads[i] = love.graphics.newQuad((i-1) * tileSizeX, 0, tileSizeX, tileSizeY, tilesetImage:getWidth(), tilesetImage:getHeight())
  end
  print("Done")

  print(map[1][1])

  tilesetBatch = love.graphics.newSpriteBatch(tilesetImage, tilesDisplayWidth * tilesDisplayHeight)
  updateTilesetBatch()
end

function updateTilesetBatch()
  tilesetBatch:clear()
  for x=0, tilesDisplayWidth-1 do
    for y=0, tilesDisplayHeight-1 do
      if math.mod(y, 2) == 0 then
        tilesetBatch:addq(tileQuads[map[x+math.floor(mapX)][y+math.floor(mapY)]+1],
        x * 2 * tileSizeX/2,
        y * 35)
      else
        print(map[x+math.floor(mapX)][y+math.floor(mapY)])
        tilesetBatch:addq(tileQuads[map[x+math.floor(mapX)][y+math.floor(mapY)]+1],
        x * 2 * tileSizeX/2 + tileSizeX/2,
        y * 35)
      end
    end
  end
end

function moveMap(dx, dy)
  oldMapX = mapX
  oldMapY = mapY
  mapX = math.max(math.min(mapX + dx, mapWidth - tilesDisplayWidth), 1)
  mapY = math.max(math.min(mapY + dy, mapHeight - tilesDisplayHeight), 1)
  -- only update if we actually moved
  if math.floor(mapX) ~= math.floor(oldMapX) or math.floor(mapY) ~= math.floor(oldMapY) then
    updateTilesetBatch()
  end
end

function love.update(dt)
  if love.keyboard.isDown("up")  then
    moveMap(0, -0.2 * -64 * dt)
  end
  if love.keyboard.isDown("down")  then
    moveMap(0, 0.2 * -64 * dt)
  end
  if love.keyboard.isDown("left")  then
    moveMap(-0.2 * -64 * dt, 0)
  end
  if love.keyboard.isDown("right")  then
    moveMap(0.2 * -64 * dt, 0)
  end
end

function love.draw()
  love.graphics.draw(tilesetBatch,
    math.floor(-(mapX%1)*tileSizeX), math.floor(-(mapY%1)*tileSizeY))
  love.graphics.print("FPS: "..love.timer.getFPS(), 10, 20)
end